.\"	$NetBSD: isp.4,v 1.11 2004/05/11 22:42:47 wiz Exp $
.\"
.\" Copyright (c) 1998, 1999
.\" 	Matthew Jacob, for NASA/Ames Research Center
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.Dd June 24, 2009
.Dt ISP 4
.Os
.Sh NAME
.Nm isp
.Nd Qlogic based SCSI and FibreChannel SCSI Host Adapters
.Sh SYNOPSIS
.Cd "isp* at pci? dev? function?" Pq PCI
.Cd "isp* at sbus? slot ? offset ?" Pq SBus
.Cd scsibus* at isp?
.Sh DESCRIPTION
This driver provides access to
.Tn SCSI
or
.Tn FibreChannel
devices.
.Pp
SCSI features include support for Ultra SCSI and wide mode transactions for
.Tn SCSI ,
and LVD (for the ISP1080 and ISP1280),
.Pp
Fibre Channel support uses FCP SCSI profile for
.Tn FibreChannel .
and uses Class 3 connections only.
Support is available for Public and Private loops.
Command tagging is supported for all (in fact,
.Tn FibreChannel
requires tagging).
.Sh CONFIGURATION
An optional
.Tn flags 0x80
appended to the above
.Tn isp*
declarations will disable the download of driver firmware, which means you
use whatever firmware is running on the card.
If no firmware is running on the card,
the driver cannot operate the card.
.Pp
An optional
.Tn flags 0x40
appended to the above
.Tn isp*
declarations (can be OR'd in with the other config flags option)
will keep the driver from looking at device or bus NVRAM settings (this
is in case NVRAM is just wrong and you have the card in a platform where
it is inconvenient to change NVRAM settings on the card).
.Sh HARDWARE
Supported cards include:
.Pp
.Bl -tag -width xxxxxx -offset indent
.It ISP1000
SBus Fast Wide, Ultra Fast Wide cards, Single Ended or Differential cards.
.It PTI SBS440
Performance Technology ISP1000 variants.
.It ISP1020
Qlogic 1020 Fast Wide and Differential Fast Wide PCI cards.
.It ISP1040
Qlogic 1040 Ultra Wide and Differential Ultra Wide PCI cards.
.It PTI SBS450
Performance Technology ISP1040 variants.
.It Qlogic 1240
Qlogic 1240 Dual Bus Ultra Wide and Differential Ultra Wide PCI cards.
.It Qlogic 1080
Qlogic 1280 LVD Ultra2 Wide PCI cards.
.It Qlogic 1280
Qlogic 1280 Dual Bus LVD Ultra2 Wide PCI cards.
.It Qlogic 2100
Qlogic 2100 and 2100A Copper and Optical Fibre Channel Arbitrated Loop
.It Qlogic 2102
Qlogic Dual Loop 2100A Optical Fibre Channel Arbitrated Loop PCI cards.
.It Qlogic 2200
Qlogic 2200 Copper and Optical Fibre Channel Arbitrated Loop PCI cards.
.It Qlogic 2202
Qlogic 2200 Dual Bus Optical Fibre Channel Arbitrated Loop PCI cards.
.It Qlogic 2204
Qlogic 2200 Quad Bus Optical Fibre Channel Arbitrated Loop PCI cards.
.It Qlogic 2300
Qlogic 2300 2-Gigabit Optical Fibre Channel PCI cards.
.It Qlogic 2312
Qlogic 2300 2-Gigabit Dual Channel Optical Fibre Channel PCI cards.
.It PTI SBS470
Performance Technology ISP2100 variants.
.It Antares P-0033
Antares Microsystems ISP2100 variants.
.It Qlogic 2400
Qlogic 2400 4-Gigabit Optical Fibre Channel PCI cards.
.It Qlogic 2500
Qlogic 2500 8-Gigabit Optical Fibre Channel PCI cards.
.El
.Sh SEE ALSO
.Xr cd 4 ,
.Xr intro 4 ,
.Xr scsi 4 ,
.Xr sd 4 ,
.Xr st 4
.Sh AUTHORS
The
.Nm
driver was written by Matthew Jacob for NASA/Ames Research Center.
.Sh BUGS
The driver currently ignores some NVRAM settings.
.Pp
The driver currently doesn't do error recovery for timed out commands
very gracefully.
.Pp
Sometimes, when booting, the driver gets stuck waiting for the Fibre Channel
firmware to tell it that the loop port database is ready.
In this case you'll see an announcement that the loop state has a
value of 0x1.
To unwedge the system, unplug and replug the fibre channel connection,
or otherwise cause a LIP (Loop Initialization Primitive sequence) -
this will kick the firmware into getting unstuck.
